/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalec.fichiers;

import java.awt.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import visuAnalec.donnees.*;
import visuAnalec.elements.*;
import visuAnalec.util.*;
import visuAnalec.util.Fichiers.*;
import visuAnalec.util.GMessages.*;

/**
 *
 * @author Bernard
 */
public abstract class FichiersTEI {
  /*  
  public static void importerCorpusTEI(final Corpus corpus) {
  final File ficTEI;
  final File repJava;
  if ((ficTEI = Fichiers.choisirFichier(Commande.OUVRIR,
  "Choix du fichier corpus TEI", Fichiers.TypeFichier.TEI))==null)
  return;
  if ((repJava = Fichiers.choisirRepertoire("Choix du répertoire Java"))==null)
  return;
  if (!repJava.exists()) {
  if (!GMessages.confirmationAction("Le répertoire spécifié n'existe pas."
  +" Voulez-vous le créer ?")) return;
  if (!repJava.mkdir()) {
  GMessages.impossibiliteAction("Echec de la création du répertoire");
  return;
  }
  }
  final GMessages.GProgression progression =
  new GMessages.GProgression(100, "Conversion", "%");
  Thread traitement = new Thread() {
  @Override
  public void run() {
  importerTEI(corpus, ficTEI, repJava, progression);
  }
  };
  traitement.start();
  }
  public static void importerTEI(Corpus corpus, File ficTEI, File repJava,
  GMessages.GProgression progression) {
  File fichierCorpus;
  File fichierAnnot;
  if ((fichierCorpus = Fichiers.choisirFichier(Commande.OUVRIR,
  "Choix du fichier corpus", Fichiers.TypeFichier.GLOZZ_CORPUS))==null)
  return;
  if ((fichierAnnot = Fichiers.choisirFichier(Commande.OUVRIR,
  "Choix du fichier annotations", Fichiers.TypeFichier.GLOZZ_ANNOT))==null)
  return;
  importer(fichierCorpus, fichierAnnot, corpus);
  corpus.newCorpusLu();
  }
  private static void importer(File fichierCorpus, File fichierAnnot, Corpus corpus) {
  BufferedReader text = null;
  BufferedInputStream annot = null;
  try {
  text = new BufferedReader(new InputStreamReader(new FileInputStream(fichierCorpus), "UTF-8"));
  annot = new BufferedInputStream(new FileInputStream(fichierAnnot));
  corpus.setTexte(text.readLine());
  SAXParserFactory pf = (SAXParserFactory) SAXParserFactory.newInstance();
  SAXParser sp = pf.newSAXParser();
  sp.parse(annot, new GlozzHandler(corpus));
  } catch (IOException ex) {
  corpus.fermer();
  JOptionPane.showMessageDialog(null, ex, "Erreur de lecture de fichier", JOptionPane.ERROR_MESSAGE);
  return;
  } catch (ParserConfigurationException ex) {
  corpus.fermer();
  JOptionPane.showMessageDialog(null, ex, "Erreur de format de fichier", JOptionPane.ERROR_MESSAGE);
  return;
  } catch (SAXException ex) {
  corpus.fermer();
  JOptionPane.showMessageDialog(null, ex, "Erreur de format de fichier", JOptionPane.ERROR_MESSAGE);
  return;
  } finally {
  try {
  if (text!=null) text.close();
  if (annot!=null) annot.close();
  } catch (IOException ex) {
  JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture du fichier lu", JOptionPane.ERROR_MESSAGE);
  }
  }
  }
  
  static class GlozzHandler extends DefaultHandler {
  Corpus corpus;
  Balise etatCourant = null;
  Element elementCourant = null;
  String champCourant = null;
  String valCourant = null;
  HashMap<String, Element> elements = new HashMap<String, Element>();
  ArrayList<Relation> relations = new ArrayList<Relation>();
  HashMap<Relation, ArrayList<String>> idTermes = new HashMap<Relation, ArrayList<String>>();
  ArrayList<Schema> schemas = new ArrayList<Schema>();
  HashMap<Schema, ArrayList<String>> idContenus = new HashMap<Schema, ArrayList<String>>();
  
  enum Balise {
  ANNOTATIONS, UNIT, RELATION, SCHEMA, METADATA, AUTHOR, CREATIONDATE,
  LASTMODIFIER, LASTMODIFICATIONDATE, CHARACTERISATION, TYPE, FEATURESET,
  FEATURE, POSITIONING, START, END, SINGLEPOSITION, TERM,
  EMBEDDEDUNIT, EMBEDDEDRELATION, EMBEDDEDSCHEMA,
  FLAG, COMMENT
  };
  static Balise balise(String nomBalise) {
  return Balise.valueOf(nomBalise.replaceAll("\\W", "").toUpperCase());
  }
  GlozzHandler(Corpus corpus) {
  super();
  this.corpus = corpus;
  }
  @Override
  public void startDocument() {
  corpus.clearAnnot();
  }
  @Override
  public void endDocument() throws SAXNotSupportedException {
  for (Relation rel : relations) {
  ArrayList<String> idterms = idTermes.get(rel);
  if (idterms.size()!=2) {
  throw new SAXNotSupportedException("Une relation de type "+rel.getType()+" n'a pas deux termes");
  }
  if (elements.get(idterms.get(0))==null) {
  throw new SAXNotSupportedException("Terme inconnu id = "+idterms.get(0)
  +" pour une relation de type "+rel.getType());
  }
  rel.setElt1(elements.get(idterms.get(0)));
  if (elements.get(idterms.get(1))==null) {
  throw new SAXNotSupportedException("Terme inconnu id = "+idterms.get(1)
  +" pour une relation de type "+rel.getType());
  }
  rel.setElt2(elements.get(idterms.get(1)));
  corpus.addRelationLue(rel);
  }
  for (Schema sch : schemas) {
  for (String id : idContenus.get(sch)) {
  if (elements.get(id)==null) {
  throw new SAXNotSupportedException("Contenu inconnu id = "+id
  +" pour un schéma de type "+sch.getType());
  }
  sch.ajouter(elements.get(id));
  }
  corpus.addSchemaLu(sch);
  }
  corpus.verifierFinParagraphesTypesUnites(new String[]{
  "title", "subTitle", "sectionTitle", "subSectionTitle",
  "subSubSectionTitle", "subSubSubSectionTitle", "quote", "listItem"});
  corpus.trierFinParagraphes();
  corpus.verifierFinParagrapheFinTexte();
  }
  @Override
  public void startElement(String uri, String local, String nomBalise, Attributes attributs) throws SAXException {
  if (etatCourant==Balise.FLAG) return;
  switch (balise(nomBalise)) {
  case FLAG:
  etatCourant = Balise.FLAG;
  break;
  case UNIT:
  elementCourant = new Unite();
  elements.put(attributs.getValue("id"), elementCourant);
  break;
  case RELATION:
  elementCourant = new Relation();
  elements.put(attributs.getValue("id"), elementCourant);
  idTermes.put((Relation) elementCourant, new ArrayList<String>());
  break;
  case SCHEMA:
  elementCourant = new Schema();
  elements.put(attributs.getValue("id"), elementCourant);
  idContenus.put((Schema) elementCourant, new ArrayList<String>());
  break;
  case TYPE:
  etatCourant = Balise.TYPE;
  valCourant = "";
  break;
  case FEATURE:
  etatCourant = Balise.FEATURE;
  champCourant = attributs.getValue("name");
  valCourant = "";
  break;
  case START:
  etatCourant = Balise.START;
  break;
  case END:
  etatCourant = Balise.END;
  break;
  case SINGLEPOSITION:
  if (elementCourant.getClass()!=Unite.class) {
  throw new SAXNotSupportedException("La balise singlePosition ne peut être utilisée que pour des unités");
  }
  if (elementCourant.getType().equals("paragraph")) {
  if (etatCourant==Balise.END) {
  corpus.addFinParagraphe(Integer.parseInt(attributs.getValue("index")));
  }
  } else {
  switch (etatCourant) {
  case START:
  ((Unite) elementCourant).setDeb(Integer.parseInt(attributs.getValue("index")));
  break;
  case END:
  ((Unite) elementCourant).setFin(Integer.parseInt(attributs.getValue("index")));
  break;
  }
  }
  break;
  case TERM:
  if (elementCourant.getClass()!=Relation.class)
  throw new SAXNotSupportedException("La balise term ne peut être utilisée que pour des relations");
  idTermes.get((Relation) elementCourant).add(attributs.getValue("id"));
  break;
  
  case EMBEDDEDUNIT:
  case EMBEDDEDRELATION:
  case EMBEDDEDSCHEMA:
  if (elementCourant.getClass()!=Schema.class)
  throw new SAXNotSupportedException(
  "Les balises embedded ne peuvent être utilisées que pour des schémas");
  idContenus.get((Schema) elementCourant).add(attributs.getValue("id"));
  break;
  }
  }
  @Override
  public void endElement(String uri, String local, String nomBalise) throws SAXException {
  if (etatCourant==Balise.FLAG) {
  if (balise(nomBalise)==Balise.FLAG) etatCourant = null;
  return;
  }
  String type = "";
  switch (balise(nomBalise)) {
  case UNIT:
  type = elementCourant.getType();
  if (type==null||type.isEmpty())
  throw new SAXNotSupportedException("Pas trouvé de type pour cette unité");
  if (!type.equals("paragraph")) {
  corpus.addUniteLue((Unite) elementCourant);
  elementCourant = null;
  }
  break;
  case RELATION:
  type = elementCourant.getType();
  if (type==null||type.isEmpty())
  throw new SAXNotSupportedException("Pas trouvé de type pour cette relation");
  relations.add((Relation) elementCourant);
  elementCourant = null;
  break;
  case SCHEMA:
  type = elementCourant.getType();
  if (type==null||type.isEmpty())
  throw new SAXNotSupportedException("Pas trouvé de type pour ce shéma");
  schemas.add((Schema) elementCourant);
  elementCourant = null;
  break;
  case TYPE:
  elementCourant.setType(valCourant);
  valCourant = null;
  etatCourant = null;
  break;
  case FEATURE:
  elementCourant.putProp(champCourant, valCourant);
  etatCourant = null;
  champCourant = null;
  valCourant = null;
  break;
  case START:
  etatCourant = null;
  break;
  case END:
  etatCourant = null;
  break;
  }
  }
  @Override
  public void characters(char[] ch, int start, int taille) throws SAXException {
  if (etatCourant==null||!EnumSet.of(Balise.TYPE, Balise.FEATURE).contains(etatCourant)) {
  return;
  }
  valCourant += new String(ch, start, taille);
  }
  }
  
  static class ModeleGlozzHandler extends DefaultHandler {
  Structure structure;
  boolean listeValeurs = false;
  Class<? extends Element> classeCourante = Unite.class;  // par défaut : balise <units> sous-entendue 
  String typeCourant = null;
  String champCourant = null;
  String valeurCourante = null;
  
  enum Balise {
  ANNOTATIONMODEL, UNITS, RELATIONS, SCHEMAS, TYPE, FEATURESET,
  FEATURE, POSSIBLEVALUES, VALUE
  };
  static Balise balise(String nomBalise) throws SAXNotRecognizedException {
  try {
  return Balise.valueOf(nomBalise.replaceAll("\\W", "").toUpperCase());
  } catch (Exception e) {
  throw new SAXNotRecognizedException("Balise non reconnue : "+nomBalise);
  }
  }
  ModeleGlozzHandler(Structure structure) {
  super();
  this.structure = structure;
  }
  @Override
  public void startDocument() {
  }
  @Override
  public void endDocument() throws SAXNotSupportedException {
  }
  @Override
  public void startElement(String uri, String local, String nomBalise, Attributes attributs) throws SAXException {
  String valdef = null;
  switch (balise(nomBalise)) {
  case UNITS:
  classeCourante = Unite.class;
  break;
  case RELATIONS:
  classeCourante = Relation.class;
  break;
  case SCHEMAS:
  classeCourante = Schema.class;
  break;
  case TYPE:
  typeCourant = attributs.getValue("name");
  if (typeCourant==null||typeCourant.isEmpty())
  throw new SAXNotSupportedException("Nom de type absent");
  structure.ajouterType(classeCourante, typeCourant);
  break;
  case FEATURE:
  if (typeCourant==null||typeCourant.isEmpty())
  throw new SAXNotSupportedException("Nom de type absent");
  champCourant = attributs.getValue("name");
  if (champCourant==null||champCourant.isEmpty())
  throw new SAXNotSupportedException("Nom de type absent");
  structure.ajouterProp(classeCourante, typeCourant, champCourant);
  break;
  case POSSIBLEVALUES:
  if (typeCourant==null||typeCourant.isEmpty()||champCourant==null||champCourant.isEmpty())
  throw new SAXNotSupportedException("Nom de type ou de feature absent");
  listeValeurs = true;
  valdef = attributs.getValue("default");
  if (valdef!=null&&!valdef.isEmpty())
  structure.modifierValParDefaut(classeCourante, typeCourant, champCourant, valdef);
  break;
  case VALUE:
  if (listeValeurs) valeurCourante = "";
  valdef = attributs.getValue("default");
  if (valdef!=null&&!valdef.isEmpty()) {
  if (typeCourant==null||typeCourant.isEmpty()||champCourant==null||champCourant.isEmpty())
  throw new SAXNotSupportedException("Nom de type ou de feature absent");
  structure.ajouterVal(classeCourante, typeCourant, champCourant, valdef);
  structure.modifierValParDefaut(classeCourante, typeCourant, champCourant, valdef);
  }
  break;
  }
  }
  @Override
  public void endElement(String uri, String local, String nomBalise) throws SAXException {
  switch (balise(nomBalise)) {
  case POSSIBLEVALUES:
  listeValeurs = false;
  break;
  case VALUE:
  if (listeValeurs&&valeurCourante!=null&&!valeurCourante.isEmpty())
  structure.ajouterVal(classeCourante, typeCourant, champCourant, valeurCourante);
  break;
  }
  }
  @Override
  public void characters(char[] ch, int start, int taille) throws SAXException {
  if (listeValeurs) {
  valeurCourante += new String(ch, start, taille);
  }
  }
  }
   */
  public final static String TYPE_INFOS_META_DOCUMENTS = "Titre";
  public final static String CHAMP_NON_RENSEIGNE = "non renseigné";
  public final static String DEFAUT_TITRE_CORPUS = "";
  public final static String DEFAUT_ANNOTATEURS = "";
  public final static String DEFAUT_EDITEUR = "";
  public final static String DEFAUT_SOURCE_CORPUS = "";
  public static void exporterCorpusTEI(final Corpus corpus) {
    File repJava;
    final File ficTEI;
    final File[] fics = Fichiers.choisirCorpus("Choix du répertoire Java",
            TypeFichier.CORPUS_ANALEC);
    if (fics.length==0) return;
    final HashMap<String, String> infosCorpus = new HashMap<String, String>();
    saisirInfosCorpus(infosCorpus);
    if ((ficTEI = Fichiers.choisirFichier(Commande.ENREGISTRER,
            "Nom du fichier TEI", Fichiers.TypeFichier.TEI))==null) return;
    final PrintWriter teiWriter;
    try {
      teiWriter = new PrintWriter(ficTEI, "UTF-8");
    } catch (FileNotFoundException ex) {
      GMessages.impossibiliteAction("Pas de fichier TEI ? ");

      return;
    } catch (UnsupportedEncodingException ex) {
      GMessages.impossibiliteAction("Pas de codage UTF8 ?");
      return;
    }
    final TEIPrinter teiPrinter = new TEIPrinter(corpus, teiWriter);
    final GMessages.GProgression progression =
            new GMessages.GProgression(fics.length, "Conversion", "fichiers");
    Thread traitement = new Thread() {
      @Override
      public void run() {
        try {
          teiPrinter.ecrireEnteteCorpus(infosCorpus);
          for (int i = 0; i<fics.length; i++) {
            if (progression.isCanceled()) break;
            progression.setNbTraites(i+1);
            File ficJava = fics[i];
            if (FichiersJava.ouvrirCorpus(corpus, ficJava, true))
              teiPrinter.ecrireDocument(Fichiers.extraireNom(ficJava));
          }
          corpus.fermer();
          teiPrinter.ecrireFinCorpus();
          teiWriter.close();
        } catch (Throwable ex) {
          GMessages.erreurFatale(ex);
        }
      }
    };
    traitement.start();
  }
  private static boolean saisirInfosCorpus(HashMap<String, String> infosCorpus) {
    final boolean[] pvalide = new boolean[1];
    SaisieInfos fenetre = new SaisieInfos(pvalide, infosCorpus);
    return pvalide[0];
  }

  private static class SaisieInfos extends JDialog {
    private SaisieInfos(final boolean[] pvalide,
            final HashMap<String, String> infosCorpus) {
      super((JFrame) null, "Informations sur le corpus", true);
      JPanel cadre = new JPanel(new BorderLayout());
      setContentPane(cadre);
      Rectangle rmax = GraphicsEnvironment.getLocalGraphicsEnvironment().getMaximumWindowBounds();
      int largeur = Math.min(rmax.width-100, 600);
      int hauteur = Math.min(rmax.height-100, 400);
      Point locFenetre = new Point((rmax.x+rmax.width)/2-largeur/2,
              (rmax.y+rmax.height)/2-hauteur/2);
      Dimension dimFenetre = new Dimension(largeur, hauteur);
      setLocation(locFenetre);
      setSize(dimFenetre);
      setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
      int hauteurCars = cadre.getFontMetrics(cadre.getFont()).getHeight()+5;
      final JTextField champTitre = new JTextField(40);
      champTitre.setMaximumSize(new Dimension(500, hauteurCars));
      champTitre.setText(DEFAUT_TITRE_CORPUS);
      final JTextField champAnnot = new JTextField(40);
      champAnnot.setMaximumSize(new Dimension(500, hauteurCars));
      champAnnot.setText(DEFAUT_ANNOTATEURS);
      final JTextField champEditeur = new JTextField(40);
      champEditeur.setMaximumSize(new Dimension(500, hauteurCars));
      champEditeur.setText(DEFAUT_EDITEUR);
      final JTextField champSource = new JTextField(40);
      champSource.setMaximumSize(new Dimension(500, hauteurCars));
      champSource.setText(DEFAUT_SOURCE_CORPUS);
      Box box = Box.createVerticalBox();
      box.add(Box.createVerticalGlue());
      Box boxTitre = Box.createHorizontalBox();
      boxTitre.add(Box.createHorizontalGlue());
      boxTitre.add(new JLabel("Titre du corpus"));
      boxTitre.add(Box.createHorizontalStrut(5));
      boxTitre.add(champTitre);
      boxTitre.add(Box.createHorizontalGlue());
      box.add(boxTitre);
      box.add(Box.createVerticalGlue());
      Box boxAnnot = Box.createHorizontalBox();
      boxAnnot.add(Box.createHorizontalGlue());
      boxAnnot.add(new JLabel("Annotateurs"));
      boxAnnot.add(Box.createHorizontalStrut(5));
      boxAnnot.add(champAnnot);
      boxAnnot.add(Box.createHorizontalGlue());
      box.add(boxAnnot);
      box.add(Box.createVerticalGlue());
      Box boxEditeur = Box.createHorizontalBox();
      boxEditeur.add(Box.createHorizontalGlue());
      boxEditeur.add(new JLabel("Editeur"));
      boxEditeur.add(Box.createHorizontalStrut(5));
      boxEditeur.add(champEditeur);
      boxEditeur.add(Box.createHorizontalGlue());
      box.add(boxEditeur);
      box.add(Box.createVerticalGlue());
      Box boxSource = Box.createHorizontalBox();
      boxSource.add(Box.createHorizontalGlue());
      boxSource.add(new JLabel("Description du corpus"));
      boxSource.add(Box.createHorizontalStrut(5));
      boxSource.add(champSource);
      boxSource.add(Box.createHorizontalGlue());
      box.add(boxSource);
      box.add(Box.createVerticalGlue());
      add(box);
      JButton valideModifs = new JButton(
              new GAction("Valider") {
                @Override
                public void executer() {
                  pvalide[0] = true;
                  infosCorpus.put("Titre", champTitre.getText());
                  infosCorpus.put("Annot", champAnnot.getText());
                  infosCorpus.put("Editeur", champEditeur.getText());
                  infosCorpus.put("Source", champSource.getText());
                  dispose();
                }
              ;
      });
    JButton annuleModifs = new JButton(
              new GAction("Annuler") {
                @Override
                public void executer() {
                  pvalide[0] = false;
                  dispose();
                }
              ;
      });
     Box boutons = Box.createHorizontalBox();
      boutons.add(Box.createGlue());
      boutons.add(valideModifs, Box.CENTER_ALIGNMENT);
      boutons.add(Box.createHorizontalStrut(5));
      boutons.add(annuleModifs, Box.CENTER_ALIGNMENT);
      boutons.add(Box.createGlue());
      add(boutons, BorderLayout.SOUTH);
      setVisible(
              true);

    }
  }

  static private class TEIPrinter {
    static private class Delimiteur implements Comparable<Delimiteur> {
      private String id;
      private int taille; // signé : négatif pour les délimiteurs de fin
      private Delimiteur(String id, int taille) {
        this.id = id;
        this.taille = taille;
      }
      public int compareTo(Delimiteur d) {
        if (taille!=d.taille) {
          if (taille<0&&d.taille<0||taille>0&&d.taille>0)
            return d.taille-taille;
          else return taille-d.taille;
        } else return taille>0 ? -d.id.compareTo(id) : d.id.compareTo(id);
      }
    }
    private Corpus corpus;
    private PrintWriter writer;
    private String titreCorpus, annot, editeur, sourceCorpus;
    private HashMap<String, ArrayList<Unite>> unites =
            new HashMap<String, ArrayList<Unite>>();
    private HashMap<String, ArrayList<Relation>> relations =
            new HashMap<String, ArrayList<Relation>>();
    private HashMap<String, ArrayList<Schema>> schemas =
            new HashMap<String, ArrayList<Schema>>();
    private HashMap<Element, String> ids = new HashMap<Element, String>();
    private HashMap<String, String> encodeName = new HashMap<String, String>();
    private HashMap<Integer, ArrayList<Delimiteur>> delimiteurs =
            new HashMap<Integer, ArrayList<Delimiteur>>();
    TEIPrinter(Corpus corpus, PrintWriter writer) {
      this.corpus = corpus;
      this.writer = writer;
    }
    private void ecrireEnteteCorpus(HashMap<String, String> infosCorpus) {
      titreCorpus = traiterSaisie(infosCorpus.get("Titre"));
      annot = traiterSaisie(infosCorpus.get("Annot"));
      editeur = traiterSaisie(infosCorpus.get("Editeur"));
      sourceCorpus = traiterSaisie(infosCorpus.get("Source"));
      writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>");
      writer.println("<teiCorpus xmlns=\"http://www.tei-c.org/ns/1.0\">");
      writer.println(" <teiHeader>");
      writer.println("<fileDesc>");
      writer.println("<titleStmt>");
      writer.println("<title>"+titreCorpus+"</title>");
      writer.println("<respStmt>");
      writer.println("<resp>annotated by</resp>");
      writer.println("<name>"+annot+"</name>");
      writer.println("</respStmt>");
      writer.println("</titleStmt>");
      writer.println("<publicationStmt>");
      writer.println("<publisher>"+editeur+"</publisher>");
      writer.println("</publicationStmt>");
      writer.println("<sourceDesc>");
      writer.println("<bibl>"+sourceCorpus+"</bibl>");
      writer.println("</sourceDesc>");
      writer.println("</fileDesc>");
      writer.println("</teiHeader>");
    }
    private void ecrireFinCorpus() {
      writer.println("</teiCorpus>");
    }
    private void preparerDonnees() {
      unites.clear();
      relations.clear();
      schemas.clear();
      ids.clear();
      encodeName.clear();
      delimiteurs.clear();
      String codeType = "";
      for (String type : corpus.getStructure().getTypes(Unite.class)) {
        Unite[] units = corpus.getUnites(type).toArray(new Unite[0]);
        Arrays.sort(units);
        if (units.length>0) {
          unites.put(type, new ArrayList<Unite>());
          codeType = encodeId(type);
          encodeName.put(type, codeType);
          for (String prop : corpus.getStructure().getNomsProps(Unite.class, type))
            encodeName.put(prop, encodeId(prop));
        }
        for (int no = 0; no<units.length; no++) {
          Unite unit = units[no];
          String id = "u-"+codeType+"-"+(no+1);
          ids.put(unit, id);
          unites.get(type).add(unit);
          int taille = unit.getFin()-unit.getDeb();
          Delimiteur del = new Delimiteur(id, taille);
          addDel(unit.getDeb(), del);
          if (taille>0) {
            del = new Delimiteur(id, -taille);
            addDel(unit.getFin(), del);
          }
        }
      }
      for (String type : corpus.getStructure().getTypes(Relation.class)) {
        Relation[] rels = corpus.getRelations(type).toArray(new Relation[0]);
        Arrays.sort(rels);
        if (rels.length>0) {
          relations.put(type, new ArrayList<Relation>());
          codeType = encodeId(type);
          encodeName.put(type, codeType);
          for (String prop : corpus.getStructure().getNomsProps(Relation.class, type))
            encodeName.put(prop, encodeId(prop));

        }
        for (int no = 0; no<rels.length; no++) {
          Relation rel = rels[no];
          String id = "r-"+codeType+"-"+(no+1);
          ids.put(rel, id);
          relations.get(type).add(rel);
        }
      }
      for (String type : corpus.getStructure().getTypes(Schema.class)) {
        Schema[] schs = corpus.getSchemas(type).toArray(new Schema[0]);
        Arrays.sort(schs);
        if (schs.length>0) {
          schemas.put(type, new ArrayList<Schema>());
          codeType = encodeId(type);
          encodeName.put(type, codeType);
          for (String prop : corpus.getStructure().getNomsProps(Schema.class, type))
            encodeName.put(prop, encodeId(prop));
        }
        for (int no = 0; no<schs.length; no++) {
          Schema sch = schs[no];
          String id = "s-"+codeType+"-"+(no+1);
          ids.put(sch, id);
          schemas.get(type).add(sch);
        }
      }
      int deb = 0;
      for (int fin : corpus.getFinParagraphes()) {
        int taille = fin-deb;
        Delimiteur del = new Delimiteur("p", taille);
        addDel(deb, del);
        if (taille>0) {
          del = new Delimiteur("p", -taille);
          addDel(fin, del);
        }
        deb = fin;
      }
    }
    private void addDel(int pos, Delimiteur del) {
      if (!delimiteurs.containsKey(pos))
        delimiteurs.put(pos, new ArrayList<Delimiteur>());
      delimiteurs.get(pos).add(del);
    }
    private void ecrireDocument(String nomfic) {
      preparerDonnees();
      writer.println("<TEI>");
      ecrireEntete(nomfic);
      writer.println("<text>");
      ecrireTexte();
      ecrireAnnot();
      writer.println("</text>");
      writer.println("</TEI>");
    }
    private void ecrireEntete(String nomfic) {
      String titre = "";
      String auteur = "";
      String source = "";
      if (!corpus.getUnites(TYPE_INFOS_META_DOCUMENTS).isEmpty()) {
        Unite infos = corpus.getUnites(TYPE_INFOS_META_DOCUMENTS).get(0);
        titre = encodeTexte(infos.getProp("titre"));
        auteur = encodeTexte(infos.getProp("auteur"));
        source = encodeTexte(infos.getProp("source"));
      }
      if (titre.isEmpty()) titre = nomfic;
      if (auteur.isEmpty()) auteur = CHAMP_NON_RENSEIGNE;
      if (source.isEmpty()) source = CHAMP_NON_RENSEIGNE;
      writer.println("<teiHeader>");
      writer.println("<fileDesc>");
      writer.println("<titleStmt>");
      writer.println("<title>"+titre+"</title>");
      writer.println("<author>"+auteur+"</author>");
      writer.println("<respStmt>");
      writer.println("<resp>annotated by</resp>");
      writer.println("<name>"+annot+"</name>");
      writer.println("</respStmt>");
      writer.println("</titleStmt>");
      writer.println("<publicationStmt>");
      writer.println("<publisher>"+editeur+"</publisher>");
      writer.println("</publicationStmt>");
      writer.println("<sourceDesc>");
      writer.println("<bibl>"+source+"</bibl>");
      writer.println("</sourceDesc>");
      writer.println("</fileDesc>");
      writer.println("</teiHeader>");
    }
    private void ecrireTexte() {
      writer.println("<body>");
      Integer[] pos = delimiteurs.keySet().toArray(new Integer[0]);
      Arrays.sort(pos);
      ecrireDel(delimiteurs.get(0));
      int deb = 0;
      for (int i = 1; i<pos.length; i++) {
        int fin = pos[i];
        writer.print(encodeTexte(corpus.getTexte().substring(deb, fin)));
        ecrireDel(delimiteurs.get(fin));
        deb = fin;
      }
      writer.println("</body>");
    }
    private void ecrireDel(ArrayList<Delimiteur> delims) {
      Delimiteur[] dels = delims.toArray(new Delimiteur[0]);
      Arrays.sort(dels);
      for (Delimiteur del : dels) {
        if (del.id.equals("p")) {
          if (del.taille>0)
            writer.println("<p>");
          else {
            writer.println();
            if (del.taille<0) writer.println("</p>");
            else writer.println("<p/>");
          }
        } else {
          String ancre1 = "<anchor xml:id=\""+del.id;
          String ancre2 = "\" type=\"AnalecDelimiter\" subtype=\"Unit";
          if (del.taille>0)
            writer.print(ancre1+"-start"+ancre2+"Start\"/>");
          else if (del.taille<0)
            writer.print(ancre1+"-end"+ancre2+"End\"/>");
          else {  // ne devrait pas se produire : une unité de taille nulle
            writer.print(ancre1+"-start"+ancre2+"Start\"/>");
            writer.print(ancre1+"-end"+ancre2+"End\"/>");
          }
        }
      }
    }
    private void ecrireAnnot() {
      writer.println("<back>");
      for (String type : unites.keySet()) {
        writer.println("<spanGrp type=\"AnalecUnit\""
                +" n=\""+encodeName.get(type)+"\">");
        for (Unite unit : unites.get(type)) ecrireUnite(unit);
        writer.println("</spanGrp>");
      }
      for (String type : relations.keySet()) {
        writer.println("<joinGrp type=\"AnalecRelation\""
                +" n=\""+encodeName.get(type)+"\">");
        for (Relation rel : relations.get(type)) ecrireRelation(rel);
        writer.println("</joinGrp>");
      }
      for (String type : schemas.keySet()) {
        writer.println("<joinGrp type=\"AnalecSchema\""
                +" n=\""+encodeName.get(type)+"\">");
        for (Schema sch : schemas.get(type)) ecrireSchema(sch);
        writer.println("</joinGrp>");
      }
      writer.println("<fvLib n=\"AnalecElementProperties\">");
      for (String type : unites.keySet())
        for (Unite unit : unites.get(type)) ecrireProps(unit);
      for (String type : relations.keySet())
        for (Relation rel : relations.get(type)) ecrireProps(rel);
      for (String type : schemas.keySet())
        for (Schema sch : schemas.get(type)) ecrireProps(sch);
      writer.println("</fvLib>");
      writer.println("</back>");
    }
    private void ecrireUnite(Unite unit) {
      String id = ids.get(unit);
      writer.println("<span xml:id=\""+id+"\"");
      writer.println("from=\"#"+id+"-start\" to=\"#"+id+"-end\"");
      writer.println("ana=\"#"+id+"-fs\"/>");
    }
    private void ecrireRelation(Relation rel) {
      String id = ids.get(rel);
      writer.println("<join xml:id=\""+ids.get(rel)+"\"");
      writer.println("target=\"#"+ids.get(rel.getElt1())
              +" #"+ids.get(rel.getElt2())+"\"");
      writer.println("ana=\"#"+id+"-fs\"/>");
    }
    private void ecrireSchema(Schema sch) {
      String id = ids.get(sch);
      writer.println("<join xml:id=\""+ids.get(sch)+"\"");
      writer.print("target=\"");
      for (Element elt : sch.getContenu())
        writer.print("#"+ids.get(elt)+" ");
      writer.println("\"");
      writer.println("ana=\"#"+id+"-fs\"/>");
    }
    private void ecrireProps(Element elt) {
      writer.println("<fs xml:id=\""+ids.get(elt)+"-fs\">");
      HashMap<String, String> props = elt.getProps();
      for (String nom : props.keySet()) {
        if (props.get(nom)!=null)
          writer.println("<f name=\""+encodeName.get(nom)+"\"><string>"
                  +encodeTexte(props.get(nom))+"</string></f>");
      }
      writer.println("</fs>");
    }
    private static String encodeTexte(String ch) {
      return ch.replaceAll("&", "&amp;").replaceAll("<", "&lt;").
              replaceAll(">", "&gt;").replaceAll("\"", "&quot;").
              replaceAll("\'", "&apos;");
    }
    final static String interdits = "[!\\\"#\\$%&'\\(\\)\\*+,/;<=>\\?"
            +"@\\[\\\\\\]\\^`\\{\\|\\}\\~]";
    private static String encodeId(String ch) {
      String id = ch.replaceAll("\\s", "_");
      if (id.matches("[-\\.0-9];*")) id = '_'+id;
      id = id.replaceAll(interdits, "\u00b7");
      if (id.substring(0, 3).equalsIgnoreCase("xml")) id = '_'+id;
      return id;
    }
    private static String traiterSaisie(String ch) {
      if (ch==null) return CHAMP_NON_RENSEIGNE;
      if (ch.trim().isEmpty()) return CHAMP_NON_RENSEIGNE;
      return encodeTexte(ch);
    }
  }
}
